
// Pocol ̃R[h蒼ĎgpĂ܂B(I.Kato)
// QlURL  http://asura.iaigiri.com/OpenGL/gl7.html 

// IWiwb_[
/*************************************************************************
@@DDSLoader.h@

@@Direct Draw Surface Loader

@@Date : Nov 01, 2007
@@Version : 1.0
@@Author : Pocol
@@Memo : DDSt@Cǂݍނ߂GLEWgp܂
*************************************************************************/

#ifndef _DDS_LOADER_H_INCLUDED_
#define _DDS_LOADER_H_INCLUDED_

//
//@include
//
//#include <iostream>
//#include <gl/glew.h>
#include <gl/glut.h>
//using namespace std;

//
//@link
//
//#pragma comment(lib, "glew32.lib")

//
//@define
//
#define FOURCC_DXT1 '1TXD'
#define FOURCC_DXT3 '3TXD'
#define FOURCC_DXT5 '5TXD'

//
//@struct
//

typedef struct _DDPixelFormat
{
	GLuint size;
	GLuint flgas;
	GLuint fourCC;
	GLuint bpp;
	GLuint redMask;
	GLuint greenMask;
	GLuint blueMask;
	GLuint alphaMask;
} DDPixelFormat;

typedef struct _DDSCaps
{
	GLuint caps;
	GLuint caps2;
	GLuint caps3;
	GLuint caps4;
} DDSCaps;

typedef struct _DDColorKey
{
	GLuint lowVal;
	GLuint highVal;
} DDColorKey;

typedef struct _DDSurfaceDesc
{
	GLuint size;
	GLuint flags;
	GLuint height;
	GLuint width;
	GLuint pitch;
	GLuint depth;
	GLuint mipMapLevels;
	GLuint alphaBitDepth;
	GLuint reserved;
	GLuint surface;

	DDColorKey ckDestOverlay;
	DDColorKey ckDestBlt;
	DDColorKey ckSrcOverlay;
	DDColorKey ckSrcBlt;

	DDPixelFormat format;
	DDSCaps caps;

	GLuint textureStage;
} DDSurfaceDesc;


//////////////////////////////////////////////////////////////////////////
//@@DDSImage class
//////////////////////////////////////////////////////////////////////////
class DDSImage
{
protected:
	GLuint imageSize;
	GLubyte *imageData;
	GLenum format;
	GLuint internalFormat;
	GLuint width;
	GLuint height;
	GLuint bpp;

	GLuint numMipmaps;

	const unsigned char *m_pData;

	bool DecompressDDS(void);

public:
	DDSImage();
	~DDSImage();

//	bool ReadDDS(const char *filename);
	bool CheckInfo(const unsigned char *pData); // DDSwb_[̊mF

	long getWidth (void) {return (long)width;}
	long getHeight(void) {return (long)height;}

	bool CreateTexture(GLuint *puiTexID); // eLX`̍쐬

//	GLuint ID;
//	GLuint Load(const char *filename);
};

#endif	//@_DDS_LOADER_H_INCLUDED_
