//**********************
// eNX`XgǗ
//**********************

#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>
#include	<gl/glut.h>
#include	"../libpng/png.h"
#include	"../zlib/zlib.h"
#include	"../TJpgDec/tjpgd.h"
#include	"DDSLoader.h"
#include	"TextureList.h"


// Qfmœ̃eNX`Ɩ肪̂ŁAO[oϐłȂ悤ɂB
//cTextureList	g_clsTextureList0; // eNX`jbg0p  cPMDModelNX̃o[ϐɕύX
//cTextureList	g_clsTextureList1; // eNX`jbg1p  


//================
// RXgN^
//================
cTextureList::cTextureList( void ) : m_pTextureList( NULL )
{
}

//==============
// fXgN^
//==============
cTextureList::~cTextureList( void )
{
	TextureData	*pTemp, *pNextTemp;

	pTemp = m_pTextureList;
	while( pTemp )
	{
		pNextTemp = pTemp->pNext;

		glDeleteTextures( 1, &pTemp->uiTexID );
		delete pTemp;

		pTemp = pNextTemp;
	}
	m_pTextureList = NULL;
}

//====================
// eNX`ID擾
//====================
unsigned int cTextureList::getTexture( const char *szFileName )
{
	unsigned int	uiTexID = 0xFFFFFFFF;

	// ܂͂łɓǂݍ܂Ă邩ǂ
	if( findTexture( szFileName, &uiTexID ) )
	{
		return uiTexID;
	}

	// Ȃ΃t@CǂݍŃeNX`쐬
	if( createTexture( szFileName, &uiTexID ) )
	{
		// VXgm[h쐬擪֐ڑ
		TextureData	*pNew = new TextureData;

		strcpy( pNew->szFileName, szFileName );
		pNew->uiTexID = uiTexID;
		pNew->uiRefCount = 1;

		pNew->pNext = m_pTextureList;
		m_pTextureList = pNew;

		return uiTexID;
	}

	return 0xFFFFFFFF;	// eNX`ǂݍ݂쐬s
}

//----------------------------------
// ǂݍݍς݂̃eNX`猟
//----------------------------------
bool cTextureList::findTexture( const char *szFileName, unsigned int *puiTexID )
{
	TextureData	*pTemp = m_pTextureList;

	while( pTemp )
	{
		if( strcmp( pTemp->szFileName, szFileName ) == 0 )
		{
			// ǂݍݍς݂̃eNX`𔭌
			*puiTexID = pTemp->uiTexID;
			pTemp->uiRefCount++;

			return true;
		}

		pTemp = pTemp->pNext;
	}

	return false;	// ł
}

//--------------------------------------
// t@CǂݍŃeNX`쐬
//--------------------------------------
bool cTextureList::createTexture( const char *szFileName, unsigned int *puiTexID )
{
	FILE	*pFile;
	fpos_t	fposFileSize;
	unsigned char
			*pData;

	pFile = fopen( szFileName, "rb" );
	if( !pFile )	return false;	// t@CJȂ

	// t@CTCY擾
	fseek( pFile, 0, SEEK_END );
	fgetpos( pFile, &fposFileSize );

	// m
	// TJpgDec  0x0200oCgǂݏoׁAXAfobK͈͊Oaccessxꍇ̂ŁA߂ɊmۂĂB
	size_t nMallocSize = (size_t)fposFileSize + 0x0200 * 2;
	pData = (unsigned char *)malloc( nMallocSize );

	// ǂݍ
	fseek( pFile, 0, SEEK_SET );
	fread( pData, 1, (size_t)fposFileSize, pFile );

	fclose( pFile );

	bool	bRet = false;


#if 0 // gqł̔ʂƁAPMX p spa, sph ̃tH[}bg`̔fɎs

	int		iLen = strlen( szFileName );

	if (iLen > 4) {

		if( 	(szFileName[iLen - 3] == 'b' || szFileName[iLen - 3] == 'B') &&
				(szFileName[iLen - 2] == 'm' || szFileName[iLen - 2] == 'M') &&
				(szFileName[iLen - 1] == 'p' || szFileName[iLen - 1] == 'P')		)
		{
			bRet = createFromBMP( pData, puiTexID );
		}
		else if((szFileName[iLen - 3] == 's' || szFileName[iLen - 3] == 'S') &&
				(szFileName[iLen - 2] == 'p' || szFileName[iLen - 2] == 'P') &&
				(szFileName[iLen - 1] == 'h' || szFileName[iLen - 1] == 'H')		)
		{
			bRet = createFromBMP( pData, puiTexID );	// *.sph BMP
		}
		else if((szFileName[iLen - 3] == 't' || szFileName[iLen - 3] == 'T') &&
				(szFileName[iLen - 2] == 'g' || szFileName[iLen - 2] == 'G') &&
				(szFileName[iLen - 1] == 'a' || szFileName[iLen - 1] == 'A')		)
		{
			bRet = createFromTGA( pData, puiTexID );
		}
		else if((szFileName[iLen - 3] == 'p' || szFileName[iLen - 3] == 'P') &&
				(szFileName[iLen - 2] == 'n' || szFileName[iLen - 2] == 'N') &&
				(szFileName[iLen - 1] == 'g' || szFileName[iLen - 1] == 'G')		)
		{
			bRet = createFromPNG( pData, puiTexID );
		}
		else if((szFileName[iLen - 3] == 'j' || szFileName[iLen - 3] == 'J') &&
				(szFileName[iLen - 2] == 'p' || szFileName[iLen - 2] == 'P') &&
				(szFileName[iLen - 1] == 'g' || szFileName[iLen - 1] == 'G')		)
		{
			bRet = createFromJPG( pData, puiTexID );
		}
		else if((szFileName[iLen - 4] == 'j' || szFileName[iLen - 4] == 'J') &&
				(szFileName[iLen - 3] == 'p' || szFileName[iLen - 3] == 'P') &&
				(szFileName[iLen - 2] == 'e' || szFileName[iLen - 2] == 'E') &&
				(szFileName[iLen - 1] == 'g' || szFileName[iLen - 1] == 'G')		)
		{
			bRet = createFromJPG( pData, puiTexID );
		}

	}

#else // t@CtH[}bg̊ȈՔf

	if( pData[0] == 'B' && pData[1] == 'M' ) // bmp
	{
		bRet = createFromBMP( pData, puiTexID );
	}
	else if( pData[fposFileSize - 18] == 'T' && pData[fposFileSize - 17] == 'R' && pData[fposFileSize - 16] == 'U' && pData[fposFileSize - 15] == 'E' ) // tga : Magict@Cɂ
	{
		bRet = createFromTGA( pData, puiTexID );
	}
	else if( pData[0] == 0x89 && pData[1] == 'P' && pData[2] == 'N' && pData[3] == 'G' ) // png
	{
		bRet = createFromPNG( pData, puiTexID );
	}
	else if( pData[0] == 0xFF && pData[1] == 0xD8 ) // jpg
	{
		bRet = createFromJPG( pData, puiTexID );
	}
	else if( pData[0] == 'D' && pData[1] == 'D' && pData[2] == 'S' && pData[3] == ' ' ) // dds
	{
		bRet = createFromDDS( pData, puiTexID );
	}
	else
	{
		// ǂĂgqŔfȂ΂ȂȂ̂
		int		iLen = strlen( szFileName );

		if (iLen > 4) {
			if(		(szFileName[iLen - 3] == 't' || szFileName[iLen - 3] == 'T') &&
					(szFileName[iLen - 2] == 'g' || szFileName[iLen - 2] == 'G') &&
					(szFileName[iLen - 1] == 'a' || szFileName[iLen - 1] == 'A')		)
			{
				// t@C "TRUEVISION-XFILE.\0"  tga t@CL
				bRet = createFromTGA( pData, puiTexID );
			}
		}
	}

#endif

	free( pData );

	return bRet;
}

//-------------------------------
// BMPt@CeNX`쐬
//-------------------------------
bool cTextureList::createFromBMP( const unsigned char *pData, unsigned int *puiTexID )
{
#pragma pack( push, 1 )
	// BMPt@Cwb_\
	struct BMPFileHeader
	{
		unsigned short	bfType;			// t@C^Cv
		unsigned int	bfSize;			// t@CTCY
		unsigned short	bfReserved1;
		unsigned short	bfReserved2;
		unsigned int	bfOffBits;		// t@C擪摜f[^܂ł̃ItZbg
	};

	// BMPwb_\
	struct BMPInfoHeader
	{
		unsigned int	biSize;			// wb_[̃TCY
		int				biWidth;		// 
		int				biHeight;		// (ȂΉAȂΏォ牺)
		unsigned short	biPlanes;		// v[(1)
		unsigned short	biBitCount;		// 1f̃rbg
		unsigned int	biCompression;
		unsigned int	biSizeImage;
		int				biXPelsPerMeter;
		int				biYPelsPerMeter;
		unsigned int	biClrUsed;		// pbg̐F
		unsigned int	biClrImportant;
	};

	// pbgf[^
	struct RGBQuad
	{
		unsigned char	rgbBlue;
		unsigned char	rgbGreen;
		unsigned char	rgbRed;
		unsigned char	rgbReserved;
	};
#pragma pack( pop )

	// BMPt@Cwb_
	BMPFileHeader	*pBMPFileHeader = (BMPFileHeader *)pData;

	if( pBMPFileHeader->bfType != ('B' | ('M' << 8)) )
	{
		return false;	// t@C^CvႤ
	}

	// BMPwb_
	BMPInfoHeader	*pBMPInfoHeader = (BMPInfoHeader *)(pData + sizeof(BMPFileHeader));

	if( pBMPInfoHeader->biBitCount == 1 || pBMPInfoHeader->biCompression != 0 )
	{
		return false;	// 1rbgJ[ƈk`ɂ͖Ή
	}

	// J[pbg
	RGBQuad			*pPalette = NULL;

	if( pBMPInfoHeader->biBitCount < 24 )
	{
		pPalette = (RGBQuad *)(pData + sizeof(BMPFileHeader) + sizeof(BMPInfoHeader));
	}

	// 摜f[^̐擪
	pData += pBMPFileHeader->bfOffBits;

	// 摜f[^1C̃oCg
	unsigned int	uiLineByte = ((pBMPInfoHeader->biWidth * pBMPInfoHeader->biBitCount + 0x1F) & (~0x1F)) / 8;

	// eNX`C[W̍쐬
	unsigned char	*pTexelData = (unsigned char *)malloc( pBMPInfoHeader->biWidth * pBMPInfoHeader->biHeight * 4 ),
					*pTexelDataTemp = pTexelData;

	if( pBMPInfoHeader->biBitCount == 4 )
	{
		// 4BitJ[
		for( int h = pBMPInfoHeader->biHeight - 1 ; h >= 0 ; h-- )
		{
			const unsigned char *pLineTop = &pData[uiLineByte * h];

			for( int w = 0 ; w < (pBMPInfoHeader->biWidth >> 1) ; w++ )
			{
				*pTexelDataTemp = pPalette[(pLineTop[w] >> 4) & 0x0F].rgbRed;	pTexelDataTemp++;
				*pTexelDataTemp = pPalette[(pLineTop[w] >> 4) & 0x0F].rgbGreen;	pTexelDataTemp++;
				*pTexelDataTemp = pPalette[(pLineTop[w] >> 4) & 0x0F].rgbBlue;	pTexelDataTemp++;
				*pTexelDataTemp = 255;											pTexelDataTemp++;

				*pTexelDataTemp = pPalette[(pLineTop[w]     ) & 0x0F].rgbRed;	pTexelDataTemp++;
				*pTexelDataTemp = pPalette[(pLineTop[w]     ) & 0x0F].rgbGreen;	pTexelDataTemp++;
				*pTexelDataTemp = pPalette[(pLineTop[w]     ) & 0x0F].rgbBlue;	pTexelDataTemp++;
				*pTexelDataTemp = 255;											pTexelDataTemp++;
			}
		}
	}
	else if( pBMPInfoHeader->biBitCount == 8 )
	{
		// 8BitJ[
		for( int h = pBMPInfoHeader->biHeight - 1 ; h >= 0 ; h-- )
		{
			const unsigned char *pLineTop = &pData[uiLineByte * h];

			for( int w = 0 ; w < pBMPInfoHeader->biWidth ; w++ )
			{
				*pTexelDataTemp = pPalette[pLineTop[w]].rgbRed;		pTexelDataTemp++;
				*pTexelDataTemp = pPalette[pLineTop[w]].rgbGreen;	pTexelDataTemp++;
				*pTexelDataTemp = pPalette[pLineTop[w]].rgbBlue;	pTexelDataTemp++;
				*pTexelDataTemp = 255;								pTexelDataTemp++;
			}
		}
	}
	else if( pBMPInfoHeader->biBitCount == 24 )
	{
		// 24BitJ[
		for( int h = pBMPInfoHeader->biHeight - 1 ; h >= 0 ; h-- )
		{
			const unsigned char *pLineTop = &pData[uiLineByte * h];

			for( int w = 0 ; w < pBMPInfoHeader->biWidth ; w++ )
			{
				*pTexelDataTemp = pLineTop[w * 3 + 2];	pTexelDataTemp++;
				*pTexelDataTemp = pLineTop[w * 3 + 1];	pTexelDataTemp++;
				*pTexelDataTemp = pLineTop[w * 3    ];	pTexelDataTemp++;
				*pTexelDataTemp = 255;					pTexelDataTemp++;
			}
		}
	}
	else if( pBMPInfoHeader->biBitCount == 32 )
	{
		// 32BitJ[
		for( int h = pBMPInfoHeader->biHeight - 1 ; h >= 0 ; h-- )
		{
			const unsigned char *pLineTop = &pData[uiLineByte * h];

			for( int w = 0 ; w < pBMPInfoHeader->biWidth ; w++ )
			{
				*pTexelDataTemp = pLineTop[w * 4 + 2];	pTexelDataTemp++;
				*pTexelDataTemp = pLineTop[w * 4 + 1];	pTexelDataTemp++;
				*pTexelDataTemp = pLineTop[w * 4    ];	pTexelDataTemp++;
//				*pTexelDataTemp = 255;					pTexelDataTemp++;
				*pTexelDataTemp = pLineTop[w * 4 + 3];	pTexelDataTemp++; // At@l
			}
		}
	}

	// eNX`̍쐬
	glGenTextures( 1, puiTexID );

	glBindTexture( GL_TEXTURE_2D, *puiTexID );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 4 );

	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

	glTexImage2D(	GL_TEXTURE_2D, 0, GL_RGBA, 
					pBMPInfoHeader->biWidth, pBMPInfoHeader->biHeight,
					0, GL_RGBA, GL_UNSIGNED_BYTE,
					pTexelData );

	float	fPrioritie = 1.0f;
	glPrioritizeTextures( 1, puiTexID, &fPrioritie );

	free( pTexelData );

	return true;
}

//-------------------------------
// TGAt@CeNX`쐬
//-------------------------------
bool cTextureList::createFromTGA( const unsigned char *pData, unsigned int *puiTexID )
{
#pragma pack( push, 1 )
	struct TGAFileHeader
	{
		unsigned char	tfIdFieldLength;
		unsigned char	tfColorMapType;
		unsigned char	tfImageType;
		unsigned short	tfColorMapIndex;
		unsigned short	tfColorMapLength;
		unsigned char	tfColorMapSize;
		unsigned short	tfImageOriginX;
		unsigned short	tfImageOriginY;
		unsigned short	tfImageWidth;
		unsigned short	tfImageHeight;
        unsigned char	tfBitPerPixel;
        unsigned char	tfDiscripter;
	};
#pragma pack( pop )

	TGAFileHeader	*pTgaFileHeader = (TGAFileHeader *)pData;

/*
0	C[WȂ
1	CfbNXJ[i256Fj
2	tJ[
3	
9	CfbNXJ[BRLEk
A	tJ[BRLEk
B	BRLEk
*/
	if( pTgaFileHeader->tfImageType != 0x02 && pTgaFileHeader->tfImageType != 0x0A )
	{
		// ΉtH[}bg
		return false;
	}

	pData += sizeof( TGAFileHeader );

	unsigned char	*pTexelData = (unsigned char *)malloc( pTgaFileHeader->tfImageWidth * pTgaFileHeader->tfImageHeight * 4 ),
					*pTexelDataTemp = pTexelData;

	if( pTgaFileHeader->tfImageType == 0x02 && pTgaFileHeader->tfBitPerPixel == 24 )
	{
		// 񈳏k24BitJ[
		if( pTgaFileHeader->tfDiscripter & 0x20 )
		{
			// ォ牺
			for( int h = 0 ; h < pTgaFileHeader->tfImageHeight ; h++ )
			{
				const unsigned char *pLineTop = &pData[(pTgaFileHeader->tfImageWidth * 3) * h];

				for( int w = 0 ; w < pTgaFileHeader->tfImageWidth ; w++ )
				{
					*pTexelDataTemp = pLineTop[w * 3 + 2];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 3 + 1];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 3    ];	pTexelDataTemp++;
					*pTexelDataTemp = 255;					pTexelDataTemp++;
				}
			}
		}
		else
		{
			// 
			for( int h = pTgaFileHeader->tfImageHeight - 1 ; h >= 0 ; h-- )
			{
				const unsigned char *pLineTop = &pData[(pTgaFileHeader->tfImageWidth * 3) * h];

				for( int w = 0 ; w < pTgaFileHeader->tfImageWidth ; w++ )
				{
					*pTexelDataTemp = pLineTop[w * 3 + 2];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 3 + 1];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 3    ];	pTexelDataTemp++;
					*pTexelDataTemp = 255;					pTexelDataTemp++;
				}
			}
		}
	}
	else if( pTgaFileHeader->tfImageType == 0x02 && pTgaFileHeader->tfBitPerPixel == 32 )
	{
		// 񈳏k32BitJ[
		if( pTgaFileHeader->tfDiscripter & 0x20 )
		{
			// ォ牺
			for( int h = 0 ; h < pTgaFileHeader->tfImageHeight ; h++ )
			{
				const unsigned char *pLineTop = &pData[(pTgaFileHeader->tfImageWidth * 4) * h];

				for( int w = 0 ; w < pTgaFileHeader->tfImageWidth ; w++ )
				{
					*pTexelDataTemp = pLineTop[w * 4 + 2];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4 + 1];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4    ];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4 + 3];	pTexelDataTemp++;
				}
			}
		}
		else
		{
			// 
			for( int h = pTgaFileHeader->tfImageHeight - 1 ; h >= 0 ; h-- )
			{
				const unsigned char *pLineTop = &pData[(pTgaFileHeader->tfImageWidth * 4) * h];

				for( int w = 0 ; w < pTgaFileHeader->tfImageWidth ; w++ )
				{
					*pTexelDataTemp = pLineTop[w * 4 + 2];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4 + 1];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4    ];	pTexelDataTemp++;
					*pTexelDataTemp = pLineTop[w * 4 + 3];	pTexelDataTemp++;
				}
			}
		}
	}
	else if( pTgaFileHeader->tfImageType == 0x0A )
	{
		// k24/32BitJ[
		if( pTgaFileHeader->tfDiscripter & 0x20 )
		{
			// ォ牺
			short	nPosX = 0,
					nPosY = 0;

            while( nPosY < pTgaFileHeader->tfImageHeight )
            {
                bool	bCompress =	((*pData) & 0x80) == 0x80;
                short	nLength = ((*pData) & 0x7F) + 1;

				pData++;

                if( bCompress )
                {
                    for( short i = 0 ; i < nLength ; i++ )
                    {
						*pTexelDataTemp = pData[2];	pTexelDataTemp++;
						*pTexelDataTemp = pData[1];	pTexelDataTemp++;
						*pTexelDataTemp = pData[0];	pTexelDataTemp++;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	*pTexelDataTemp = pData[3];
						else										*pTexelDataTemp = 255;
						pTexelDataTemp++;

						nPosX++;
						if( pTgaFileHeader->tfImageWidth <= nPosX )
						{
							nPosX = 0;
							nPosY++;
						}
                    }

					if( pTgaFileHeader->tfBitPerPixel == 32 )	pData += 4;
					else										pData += 3;
                }
                else
                {
                    for( short i = 0 ; i < nLength ; i++ )
                    {
						*pTexelDataTemp = pData[2];	pTexelDataTemp++;
						*pTexelDataTemp = pData[1];	pTexelDataTemp++;
						*pTexelDataTemp = pData[0];	pTexelDataTemp++;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	*pTexelDataTemp = pData[3];
						else										*pTexelDataTemp = 255;
						pTexelDataTemp++;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	pData += 4;
						else										pData += 3;

                        nPosX++;
                        if( pTgaFileHeader->tfImageWidth <= nPosX )
                        {
                            nPosX = 0;
                            nPosY++;
                        }
                    }
                }
            }
		}
		else
		{
			// 
			short	nPosX = 0,
					nPosY = pTgaFileHeader->tfImageHeight - 1;

            while( 0 <= nPosY )
            {
                bool	bCompress =	((*pData) & 0x80) == 0x80;
                short	nLength = ((*pData) & 0x7F) + 1;

				pData++;

                if( bCompress )
                {
                    for( short i = 0 ; i < nLength ; i++ )
                    {
						pTexelDataTemp = &pTexelData[(nPosX + nPosY * pTgaFileHeader->tfImageWidth) * 4];

						*pTexelDataTemp = pData[2];	pTexelDataTemp++;
						*pTexelDataTemp = pData[1];	pTexelDataTemp++;
						*pTexelDataTemp = pData[0];	pTexelDataTemp++;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	*pTexelDataTemp = pData[3];
						else										*pTexelDataTemp = 255;

						nPosX++;
						if( pTgaFileHeader->tfImageWidth <= nPosX )
						{
							nPosX = 0;
							nPosY--;
						}
                    }

					if( pTgaFileHeader->tfBitPerPixel == 32 )	pData += 4;
					else										pData += 3;
                }
                else
                {
                    for( short i = 0 ; i < nLength ; i++ )
                    {
						pTexelDataTemp = &pTexelData[(nPosX + nPosY * pTgaFileHeader->tfImageWidth) * 4];

						*pTexelDataTemp = pData[2];	pTexelDataTemp++;
						*pTexelDataTemp = pData[1];	pTexelDataTemp++;
						*pTexelDataTemp = pData[0];	pTexelDataTemp++;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	*pTexelDataTemp = pData[3];
						else										*pTexelDataTemp = 255;

						if( pTgaFileHeader->tfBitPerPixel == 32 )	pData += 4;
						else										pData += 3;

                        nPosX++;
                        if( pTgaFileHeader->tfImageWidth <= nPosX )
                        {
                            nPosX = 0;
                            nPosY--;
                        }
                    }
                }
            }
		}
	}

	// eNX`̍쐬
	glGenTextures( 1, puiTexID );

	glBindTexture( GL_TEXTURE_2D, *puiTexID );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 4 );

	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

	glTexImage2D(	GL_TEXTURE_2D, 0, GL_RGBA, 
					pTgaFileHeader->tfImageWidth, pTgaFileHeader->tfImageHeight,
					0, GL_RGBA, GL_UNSIGNED_BYTE,
					pTexelData );

	float	fPrioritie = 1.0f;
	glPrioritizeTextures( 1, puiTexID, &fPrioritie );

	free( pTexelData );

	return true;
}


//-------------------------------
// PNG ֌W
// libpng 1.6.13 gp
//-------------------------------

// CP[W
extern "C" {

// PNG [U[f[^\
typedef struct PngUserData {
	const unsigned char *pData;
} PngUserData_t;


// libpng Ăяo֐: PNG f[^o
void png_user_read_fn (png_structp png_ptr, png_bytep buff, png_size_t length)
{
	// png_ptr  PngUserData \̂o
	PngUserData_t * pPngUserData = (PngUserData_t *)png_get_io_ptr(png_ptr);

	if (buff && length) {
		// buff  NULL łȂAbuff ɃRs[
		memcpy (buff, pPngUserData->pData, length);
	}

	// ̈ʒuɈړĂ
	pPngUserData->pData += length;
}

} // extern "C"

//-------------------------------
// PNGt@CeNX`쐬
// libpng\example.c  read_png() 
//-------------------------------
bool cTextureList::createFromPNG( const unsigned char *pData, unsigned int *puiTexID )
{
   png_structp png_ptr;
   png_infop info_ptr;
   unsigned int sig_read = 0;
   png_uint_32 width, height;
   int bit_depth, color_type, interlace_type;
   unsigned char *pTexelData = NULL;

   /* Create and initialize the png_struct with the desired error handler
    * functions.  If you want to use the default stderr and longjump method,
    * you can supply NULL for the last three parameters.  We also supply the
    * the compiler header file version, so that we know if the application
    * was compiled with a compatible version of the library.  REQUIRED
    */
   png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);

   if (png_ptr == NULL)
   {
      return false;
   }

   /* Allocate/initialize the memory for image information.  REQUIRED. */
   info_ptr = png_create_info_struct(png_ptr);
   if (info_ptr == NULL)
   {
      png_destroy_read_struct(&png_ptr, NULL, NULL);
      return false;
   }

   /* Set error handling if you are using the setjmp/longjmp method (this is
    * the normal method of doing things with libpng).  REQUIRED unless you
    * set up your own error handlers in the png_create_read_struct() earlier.
    */

   if (setjmp(png_jmpbuf(png_ptr)))
   {
      /* Free all of the memory associated with the png_ptr and info_ptr */
      png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
      /* If we get here, we had a problem reading the file */
      return false;
   }


#if 000

   /* One of the following I/O initialization methods is REQUIRED */
#ifdef streams /* PNG file I/O method 1 */
   /* Set up the input control if you are using standard C streams */
   png_init_io(png_ptr, fp);

#else no_streams /* PNG file I/O method 2 */
   /* If you are using replacement read functions, instead of calling
    * png_init_io() here you would call:
    */
   png_set_read_fn(png_ptr, (void *)user_io_ptr, user_read_fn);
   /* where user_io_ptr is a structure you want available to the callbacks */
#endif no_streams /* Use only one I/O method! */

#else

   // FILE* ł͂ȂA(pData) PNGf[^o悤ɂ
   PngUserData_t png_user_data; // [U[f[^\
   png_user_data.pData = pData;
   png_set_read_fn(png_ptr, (void *)&png_user_data, png_user_read_fn);

#endif

   /* If we have already read some of the signature */
   png_set_sig_bytes(png_ptr, sig_read);


//#ifdef hilevel    hilevel͎gȂBlower-levelŏB
   /*
    * If you have enough memory to read in the entire image at once,
    * and you need to specify only transforms that can be controlled
    * with one of the PNG_TRANSFORM_* bits (this presently excludes
    * quantizing, filling, setting background, and doing gamma
    * adjustment), then you can read the entire image (including
    * pixels) into the info structure with this call:
    */
//   png_read_png(png_ptr, info_ptr, png_transforms, NULL);

//#else
   /* OK, you're doing it the hard way, with the lower-level functions */

   /* The call to png_read_info() gives us all of the information from the
    * PNG file before the first IDAT (image data chunk).  REQUIRED
    */
   png_read_info(png_ptr, info_ptr);

   png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type,
       &interlace_type, NULL, NULL);

   /* Set up the data transformations you want.  Note that these are all
    * optional.  Only call them if you want/need them.  Many of the
    * transformations only work on specific types of images, and many
    * are mutually exclusive.
    */
    // width  height ꂽ̂ŁAeNX`p̃mۂ
    pTexelData = (unsigned char *)malloc( width * height * 4 ); // 4RGBA4oCg̈Ӗ

   /* Tell libpng to strip 16 bit/color files down to 8 bits/color.
    * Use accurate scaling if it's available, otherwise just chop off the
    * low byte.
    */
    // 16bit/color  png ͖yĂȂAAMMD fp̃eNX`̃xȂ
    // png_set_strip_16() ł\Ǝv̂Apnglibconf.h  PNG_READ_SCALE_16_TO_8_SUPPORTED 
    // ɂƁARpCʂȂ̂ŁAʓ|Ȃ̂ŁÂ܂܂ɂĂB
#ifdef PNG_READ_SCALE_16_TO_8_SUPPORTED
    png_set_scale_16(png_ptr);  // Y킾ᑬBϊe[u݂Ȃ̂쐬ĂlŁAHBRAvOTCY傫ȂB
#else
   png_set_strip_16(png_ptr);  // GB
#endif

   /* Strip alpha bytes from the input data without combining with the
    * background (not recommended).
    */
//   png_set_strip_alpha(png_ptr);  // At@l strip Ɏc

   /* Extract multiple pixels with bit depths of 1, 2, and 4 from a single
    * byte into separate bytes (useful for paletted and grayscale images).
    */
   png_set_packing(png_ptr); // 

   /* Change the order of packed pixels to least significant bit first
    * (not useful if you are using png_set_packing). */
//   png_set_packswap(png_ptr); // png_set_packing()gĂ̂ŕsvƎv

   /* Expand paletted colors into true RGB triplets */
   if (color_type == PNG_COLOR_TYPE_PALETTE)
      png_set_palette_to_rgb(png_ptr); // 

   /* Expand grayscale images to the full 8 bits from 1, 2, or 4 bits/pixel */
   if (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8)
      png_set_expand_gray_1_2_4_to_8(png_ptr); // 

   /* Expand paletted or RGB images with transparency to full alpha channels
    * so the data will be available as RGBA quartets.
    */
   if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
      png_set_tRNS_to_alpha(png_ptr);  // 

   /* Set the background color to draw transparent and alpha images over.
    * It is possible to set the red, green, and blue components directly
    * for paletted images instead of supplying a palette index.  Note that
    * even if the PNG file supplies a background, you are not required to
    * use it - you should use the (solid) application background if it has one.
    */

#if 0  // At@ݒ肳Ăf́Â܂܂ɂ̂ŁAɂ
   png_color_16 *image_background;

   if (png_get_bKGD(png_ptr, info_ptr, &image_background)) {
      png_set_background(png_ptr, image_background,
                         PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
   } else {
      png_color_16 my_background = {0, 0, 0, 0};
      png_set_background(png_ptr, &my_background,
                         PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
   }
#endif

#if 000
   /* Some suggestions as to how to get a screen gamma value
    *
    * Note that screen gamma is the display_exponent, which includes
    * the CRT_exponent and any correction for viewing conditions
    */
   if (/* We have a user-defined screen gamma value */)
   {
      screen_gamma = user-defined screen_gamma;
   }
   /* This is one way that applications share the same screen gamma value */
   else if ((gamma_str = getenv("SCREEN_GAMMA")) != NULL)
   {
      screen_gamma = atof(gamma_str);
   }
   /* If we don't have another value */
   else
   {
      screen_gamma = PNG_DEFAULT_sRGB;  /* A good guess for a PC monitor
                                           in a dimly lit room */
      screen_gamma = PNG_GAMMA_MAC_18 or 1.0; /* Good guesses for Mac systems */
   }
#else
   // XN[K}l͌ߑł
   double screen_gamma = PNG_DEFAULT_sRGB;  /* A good guess for a PC monitor in a dimly lit room */
#endif

   /* Tell libpng to handle the gamma conversion for you.  The final call
    * is a good guess for PC generated images, but it should be configurable
    * by the user at run time by the user.  It is strongly suggested that
    * your application support gamma correction.
    */

   int intent;

   if (png_get_sRGB(png_ptr, info_ptr, &intent))
      png_set_gamma(png_ptr, screen_gamma, PNG_DEFAULT_sRGB);
   else
   {
      double image_gamma;
      if (png_get_gAMA(png_ptr, info_ptr, &image_gamma))
         png_set_gamma(png_ptr, screen_gamma, image_gamma);
      else
         png_set_gamma(png_ptr, screen_gamma, 0.45455);
   }

#ifdef PNG_READ_QUANTIZE_SUPPORTED   //  256 F Windows ȂĖ̂ŁAgȂ
   /* Quantize RGB files down to 8 bit palette or reduce palettes
    * to the number of colors available on your screen.
    */
   if (color_type & PNG_COLOR_MASK_COLOR)
   {
      int num_palette;
      png_colorp palette;

      /* This reduces the image to the application supplied palette */
      if (/* We have our own palette */)
      {
         /* An array of colors to which the image should be quantized */
         png_color std_color_cube[MAX_SCREEN_COLORS];

         png_set_quantize(png_ptr, std_color_cube, MAX_SCREEN_COLORS,
            MAX_SCREEN_COLORS, NULL, 0);
      }
      /* This reduces the image to the palette supplied in the file */
      else if (png_get_PLTE(png_ptr, info_ptr, &palette, &num_palette))
      {
         png_uint_16p histogram = NULL;

         png_get_hIST(png_ptr, info_ptr, &histogram);

         png_set_quantize(png_ptr, palette, num_palette,
                        max_screen_colors, histogram, 0);
      }
   }
#endif /* PNG_READ_QUANTIZE_SUPPORTED */

   /* Invert monochrome files to have 0 as white and 1 as black */
//   png_set_invert_mono(png_ptr);  // ʂ0ŁA1˂[́HȂ̂ŁAB

#if 1  // ̏̕Ȃ̂AłĂȂAꉞALɂĂB
   /* If you want to shift the pixel values from the range [0,255] or
    * [0,65535] to the original [0,7] or [0,31], or whatever range the
    * colors were originally in:
    */
   if (png_get_valid(png_ptr, info_ptr, PNG_INFO_sBIT))
   {
      png_color_8p sig_bit_p;

      png_get_sBIT(png_ptr, info_ptr, &sig_bit_p);
      png_set_shift(png_ptr, sig_bit_p);
   }
#endif

#if 0  // RGBA ̏ɂ̂Ŗ
   /* Flip the RGB pixels to BGR (or RGBA to BGRA) */
   if (color_type & PNG_COLOR_MASK_COLOR)
      png_set_bgr(png_ptr);
#endif

#if 0 // RGBA ̏ɂ̂Ŗ
   /* Swap the RGBA or GA data to ARGB or AG (or BGRA to ABGR) */
   png_set_swap_alpha(png_ptr);
#endif

   /* Swap bytes of 16 bit files to least significant byte first */
   // png_set_scale_16()  8bit ɌFĂ邩svƎv񂾂A
   // FOł 16bit ̎舵̎Ȃ̂ŁAÔߗLɂĂB
   png_set_swap(png_ptr);

   /* Add filler (or alpha) byte (before/after each RGB triplet) */
   png_set_filler(png_ptr, 0xff, PNG_FILLER_AFTER);  // At@ png ̏ꍇ́A=255 ɂ

   unsigned int number_passes, pass, y;

#ifdef PNG_READ_INTERLACING_SUPPORTED  // ܂ɃC^[[X png L̂ŁAC^[[X͍s
   /* Turn on interlace handling.  REQUIRED if you are not using
    * png_read_image().  To see how to handle interlacing passes,
    * see the png_read_row() method below:
    */
   number_passes = png_set_interlace_handling(png_ptr);
#else
   number_passes = 1;
#endif /* PNG_READ_INTERLACING_SUPPORTED */


   /* Optional call to gamma correct and add the background to the palette
    * and update info structure.  REQUIRED if you are expecting libpng to
    * update the palette for you (ie you selected such a transform above).
    */
   png_read_update_info(png_ptr, info_ptr);

   /* Allocate the memory to hold the image using the fields of info_ptr. */

#if 000

   /* The easiest way to read the image: */
   png_bytep row_pointers[height];

   /* Clear the pointer array */
   for (row = 0; row < height; row++)
      row_pointers[row] = NULL;

   for (row = 0; row < height; row++)
      row_pointers[row] = png_malloc(png_ptr, png_get_rowbytes(png_ptr,
         info_ptr));

   /* Now it's time to read the image.  One of these methods is REQUIRED */
#ifdef entire /* Read the entire image in one go */
   png_read_image(png_ptr, row_pointers);

#else no_entire /* Read the image one or more scanlines at a time */
   /* The other way to read images - deal with interlacing: */

   for (pass = 0; pass < number_passes; pass++)
   {
#ifdef single /* Read the image a single row at a time */
      for (y = 0; y < height; y++)
      {
         png_read_rows(png_ptr, &row_pointers[y], NULL, 1);
      }

#else no_single /* Read the image several rows at a time */
      for (y = 0; y < height; y += number_of_rows)
      {
#ifdef sparkle /* Read the image using the "sparkle" effect. */
         png_read_rows(png_ptr, &row_pointers[y], NULL,
            number_of_rows);
#else no_sparkle /* Read the image using the "rectangle" effect */
         png_read_rows(png_ptr, NULL, &row_pointers[y],
            number_of_rows);
#endif no_sparkle /* Use only one of these two methods */
      }

      /* If you want to display the image after every pass, do so here */
#endif no_single /* Use only one of these two methods */
   }
#endif no_entire /* Use only one of these two methods */

#else

   // 摜p̃͊ɊmۂĂ̂ŁA̒Pȏō\ȂB

   /* The other way to read images - deal with interlacing: */
   for (pass = 0; pass < number_passes; pass++) // C^[[X
   {
      png_bytep row_pointer = pTexelData; // C^[[X̏ꍇAx㏑̂ŁAsxArow_pointer ݒ肵ȂKv
      for (y = 0; y < height; y++)
      {
         png_read_row (png_ptr, row_pointer, NULL); // PC
         row_pointer += width * 4; // 4RGBA4oCg̈Ӗ
      }
   }

#endif

   /* Read rest of file, and get additional chunks in info_ptr - REQUIRED */
   png_read_end(png_ptr, info_ptr);
//#endif hilevel

   /* At this point you have read the entire image */

   /* Clean up after the read, and free any memory allocated - REQUIRED */
   png_destroy_read_struct(&png_ptr, &info_ptr, NULL);



	// eNX`̍쐬
	glGenTextures( 1, puiTexID );

	glBindTexture( GL_TEXTURE_2D, *puiTexID );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 4 );

	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

	glTexImage2D(	GL_TEXTURE_2D, 0, GL_RGBA, 
					width, height,
					0, GL_RGBA, GL_UNSIGNED_BYTE,
					pTexelData );

	float	fPrioritie = 1.0f;
	glPrioritizeTextures( 1, puiTexID, &fPrioritie );

	// 
	free( pTexelData );

	return true;
}


//-------------------------------
// JPG ֌W
// TJpgDec R0.01b gpB
// ӁFTJpgDec  Progressive JPEG ΉBʏ JPEG ̂݁B
//-------------------------------

// CP[W
extern "C" {

// JPG [U[f[^\
typedef struct JpgUserData {
	const unsigned char *pData;
    BYTE *fbuf;    /* Pointer to the frame buffer for output function */
    UINT  wfbuf;   /* Width of the frame buffer [pix] */
} JpgUserData_t;


// TJpgDec Ăяo֐: JPG f[^o
UINT jpg_user_in_func (JDEC* jd, BYTE* buff, UINT ndata)
{
	// jd  JpgUserData \̂o
	JpgUserData_t * pJpgUserData = (JpgUserData_t *)jd->device;   /* Device identifier for the session (5th argument of jd_prepare function) */

	if (buff && ndata) {
		// buff  NULL łȂAbuff ɃRs[BNULL ̎͋ǂݎwB
		memcpy (buff, pJpgUserData->pData, ndata);
	}

	// ̈ʒuɈړĂ
	pJpgUserData->pData += ndata;

	return ndata;
}

// TJpgDec Ăяo֐: WJ JPG 摜̋`(Ԃ88)AeNX`pɏ
UINT jpg_user_out_func (JDEC* jd, void* bitmap, JRECT* rect)
{
    BYTE *src, *dst;
    UINT x, y, pws, bwd;

	// jd  JpgUserData \̂o
	JpgUserData_t * pJpgUserData = (JpgUserData_t *)jd->device;   /* Device identifier for the session (5th argument of jd_prepare function) */

    /* Put progress indicator */
//    if (rect->left == 0) {
//        printf("\r%lu%%", (rect->top << jd->scale) * 100UL / jd->height);
//    }

    /* Copy the decompressed RGB rectanglar to the frame buffer (assuming RGBA8888 cfg) */
    src = (BYTE*)bitmap;
    dst = pJpgUserData->fbuf + 4 * (rect->top * pJpgUserData->wfbuf + rect->left);  /* Left-top of destination rectangular */
    pws = 1 * (rect->right - rect->left + 1);     /* Width of source rectangular [pixel] */
    bwd = 4 * (pJpgUserData->wfbuf - pws);        /* Width of frame buffer [byte] */
    for (y = rect->top; y <= rect->bottom; y++) {
        for (x = 0; x < pws; x++) {
        	*dst++ = *src++; // R
        	*dst++ = *src++; // G
        	*dst++ = *src++; // B
        	*dst++ = 0xFF;   // A
        }
        dst += bwd;  /* Next line */
    }

    return 1;    /* Continue to decompress */
}

} // extern "C"

//-------------------------------
// JPGt@CeNX`쐬
//-------------------------------
bool cTextureList::createFromJPG( const unsigned char *pData, unsigned int *puiTexID )
{
    void *work;       /* Pointer to the decompressor work area */
    JDEC jdec;        /* Decompression object */
    JRESULT res;      /* Result code of TJpgDec API */

    /* Allocate a work area for TJpgDec */
    work = malloc(3100);
    if (work == NULL) {
    	return false;
   	}

   // FILE* ł͂ȂA(pData) JPGf[^o悤ɂ
   JpgUserData_t jpg_user_data; // [U[f[^\
   jpg_user_data.pData = pData;

    /* Prepare to decompress */
    res = jd_prepare (&jdec, jpg_user_in_func, work, 3100, &jpg_user_data);
    if (res != JDR_OK) {
//        printf("Failed to prepare: rc=%d\n", res);
	    free(work);             /* Discard work area */
		return false;
    }

    /* Ready to dcompress. Image info is available here. */
//    printf("Image dimensions: %u by %u. %u bytes used.\n", jdec.width, jdec.height, 3100 - jdec.sz_pool);

    // width  height ꂽ̂ŁAeNX`p̃mۂ
    jpg_user_data.fbuf  = (BYTE *)malloc(4 * jdec.width * jdec.height); /* Frame buffer for output image (assuming RGBA8888 cfg) */
    jpg_user_data.wfbuf = jdec.width;

    res = jd_decomp (&jdec, jpg_user_out_func, 0);   /* Start to decompress with 1/1 scaling */
    if (res == JDR_OK) {
        /* Decompression succeeded. You have the decompressed image in the frame buffer here. */
//        printf("\rOK  \n");

		// eNX`̍쐬
		glGenTextures( 1, puiTexID );

		glBindTexture( GL_TEXTURE_2D, *puiTexID );
		glPixelStorei( GL_UNPACK_ALIGNMENT, 4 );

		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

		glTexImage2D(	GL_TEXTURE_2D, 0, GL_RGBA, 
						jdec.width, jdec.height,
						0, GL_RGBA, GL_UNSIGNED_BYTE,
						jpg_user_data.fbuf );

		float	fPrioritie = 1.0f;
		glPrioritizeTextures( 1, puiTexID, &fPrioritie );

    } else {
//        printf("Failed to decompress: rc=%d\n", res);
    }

    free(jpg_user_data.fbuf);    /* Discard frame buffer */

    free(work);             /* Discard work area */

	return (res == JDR_OK);
}


//-------------------------------
// DDSt@CeNX`쐬
//-------------------------------
bool cTextureList::createFromDDS( const unsigned char *pData, unsigned int *puiTexID )
{
    DDSImage img;

	// DDSwb_[̊mF
	if (img.CheckInfo(pData) == false) {
		return false;
	}

	// eNX`̍쐬
	if (img.CreateTexture(puiTexID) == false) {
		return false;
	}

	float	fPrioritie = 1.0f;
	glPrioritizeTextures( 1, puiTexID, &fPrioritie );

	return true;
}


//==============
// fobO\
//==============
void cTextureList::debugDraw( void )
{
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );

	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D( 0.0f, (float)glutGet( GLUT_WINDOW_WIDTH ), 0.0f, (float)glutGet( GLUT_WINDOW_HEIGHT ) );

	glMatrixMode( GL_MODELVIEW );
	glPushMatrix();
	glLoadIdentity();

	glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );

	glEnable( GL_TEXTURE_2D );

	TextureData	*pTemp = m_pTextureList;
	float		fPosX = 0.0f,
				fPosY = glutGet( GLUT_WINDOW_HEIGHT );

	#define		DISP_SIZE	64.0f

	while( pTemp )
	{
		glBindTexture( GL_TEXTURE_2D, pTemp->uiTexID );

		glBegin( GL_TRIANGLE_FAN );
			glTexCoord2f( 1.0f, 1.0f );	glVertex2f( fPosX,             fPosY - DISP_SIZE );
			glTexCoord2f( 1.0f, 0.0f );	glVertex2f( fPosX + DISP_SIZE, fPosY - DISP_SIZE );
			glTexCoord2f( 0.0f, 0.0f );	glVertex2f( fPosX + DISP_SIZE, fPosY             );
			glTexCoord2f( 0.0f, 1.0f );	glVertex2f( fPosX,             fPosY             );
		glEnd();

		fPosX += DISP_SIZE + 2.0f;
		if( fPosX >= glutGet( GLUT_WINDOW_WIDTH ) - DISP_SIZE )
		{
			fPosX  =             0.0f;
			fPosY -= DISP_SIZE + 2.0f;
		}

		pTemp = pTemp->pNext;
	}

	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );
	glPopMatrix();

	glEnable( GL_DEPTH_TEST );
	glEnable( GL_LIGHTING );
}

//================
// eNX`
//================
void cTextureList::releaseTexture( unsigned int uiTexID )
{
	TextureData	*pTemp = m_pTextureList,
				*pPrevTemp = NULL;

	while( pTemp )
	{
		if( pTemp->uiTexID == uiTexID )
		{
			pTemp->uiRefCount--;
			if( pTemp->uiRefCount <= 0 )
			{
				glDeleteTextures( 1, &pTemp->uiTexID );

				if( pPrevTemp )	pPrevTemp->pNext = pTemp->pNext;
				else			m_pTextureList   = pTemp->pNext;

				delete pTemp;
			}

			return;
		}

		pPrevTemp = pTemp;
		pTemp     = pTemp->pNext;
	}
}
