//*******
// PMDIK
//*******

#ifndef		_PMDIK_H_
#define		_PMDIK_H_

#include	"PMDTypes.h"
#include	"PMXTypes.h"
#include	"PMDBone.h"

class cPMDIK
{
	private :
		cPMDBone		*m_pTargetBone;	// IK^[Qbg{[
		cPMDBone		*m_pEffBone;	// IK[{[: PMD/PMXGfB^ł́Aꂪ^[QbgƂ̂ɂȂĂ

		unsigned short	m_unCount;		// ċAZ // IKl1
		float			m_fFact;		// Z1񂠂̐px // IKl2
		short			m_nSortVal;		// IK\擪{[ԍ

		unsigned char	m_cbNumLink;	// IK\{[̐
		cPMDBone		**m_ppBoneList;	// IK\{[̔z

		void limitAngle( Vector4 *pvecOut, const Vector4 *pvecSrc );

	public :
		cPMDIK( void );
		~cPMDIK( void );

//		void initialize( const PMD_IK *pPMDIKData, cPMDBone pBoneArray[] );
		void initialize( const PMX_IK *pPMXIKData, cPMDBone pBoneArray[] );

		void update( void );
		void debugDraw( void );

		void release();

		inline short getSortVal( void ){ return m_nSortVal; }
};

#endif	// _PMDIK_H_
